//We always have to include the library
#include "LedControl.h"

/*
 Now we need a LedControl to work with.
 ***** These pin numbers will probably not work with your hardware *****
 pin 12 is connected to the DataIn 2
 pin 11 is connected to the CLK 0
 pin 10 is connected to LOAD 1
 We have only a single MAX72XX.
 */
LedControl lc=LedControl(12,11,10,1); //12(Din), 11(CLK), 10(LOAD), 1(# of max Chips)

//we always wait a bit between updates of the display
unsigned long delaytime=250;
int marker = 1;

//Initialize 8 bit binary value for each die face
int die[7] = {B00000000,B00000001,B00010010,B00010011,B01011010,B01011011,B01111110};
//Initialize 8 bit binary value for roll animation
int roll[6] = {B01000000,B00100000,B00010000,B00001000,B00000100,B00000010};

const int buttonPin = 3;
int buttonState = 0;

int rand1 = 0;
int rand2 = 0;
int rand3 = 0;
int rand4 = 0;
int rand5 = 0;
//int rand6 = 0;

void setup() {
  //The MAX72XX is in power-saving mode on startup,we have to do a wakeup call
  lc.shutdown(0,false);
  //Set the brightness to a medium values
  lc.setIntensity(0,15);
  //and clear the display
  lc.clearDisplay(0);
  
  pinMode(buttonPin, INPUT);

  randomSeed(analogRead(0));
}

void rollDice() {
  for(int i=0;i<6;i++) {
    lc.setRow(0,0,roll[i]);
    lc.setRow(0,1,roll[i]);
    lc.setRow(0,2,roll[i]);
    lc.setRow(0,3,roll[i]);
    lc.setRow(0,4,roll[i]);
    //lc.setRow(0,5,roll[i]);
    delay(100);
  }
}

void scrollDigits() {
  for(int i=1;i<7;i++) {
    lc.setRow(0,0,die[i]);
    lc.setRow(0,1,die[i]);
    lc.setRow(0,2,die[i]);
    lc.setRow(0,3,die[i]);
    lc.setRow(0,4,die[i]);
    //lc.setRow(0,5,die[i]);
    delay(200+(15*i));
  }
}

void loop() { 
  buttonState = digitalRead(buttonPin);
  if (buttonState == HIGH) {
    rollDice();
    rand1 = random(1,7);
    rand2 = random(1,7);
    rand3 = random(1,7);
    rand4 = random(1,7);
    rand5 = random(1,7);
    //rand6 = random(1,7);
    marker = 1;
  }
  else if (marker == 1) {
    scrollDigits();
    lc.clearDisplay(0);
    delay(delaytime);
    marker = 0;
  }
  else {
    delay(100);
    // lc.setRow(address,digit,8 bit value corresponding to die face)
    lc.setRow(0,0,die[rand1]);
    lc.setRow(0,1,die[rand2]);
    lc.setRow(0,2,die[rand3]);
    lc.setRow(0,3,die[rand4]);
    lc.setRow(0,4,die[rand5]);
    //lc.setRow(0,5,die[rand6]); //for total of 6 die
  }
}
